> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://mailchimp.com/developer/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://mailchimp.com/developer/_mcp/server.

# Start batch operation

POST https://api.mailchimp.com/3.0/batches
Content-Type: application/json

Begin processing a batch operations request.

Reference: https://mailchimp.com/developer/marketing/api/batches/create

## Authentication

- `Authorization` header (bearer token, required) — Authorization using a Mailchimp API key (a.k.a. Bearer token)
- `Authorization` header (bearer token, required) — Authorization using OAuth

## Request

### Body (application/json)

This endpoint expects an object.

- `operations` (list of 30BatchesPostRequestBodyContentApplicationJsonSchemaOperationsItems, required) — An array of objects that describes operations to perform.

## Response

### 200

- `_links` (list of BatchLinksItems, optional) — A list of link types and descriptions for the API schema documents.
- `completed_at` (BatchCompletedAt, optional) — The date and time when all operations in the batch request completed in ISO 8601 format.
- `errored_operations` (integer, optional) — The number of completed operations that returned an error.
- `finished_operations` (integer, optional) — The number of completed operations. This includes operations that returned an error.
- `id` (string, optional) — A string that uniquely identifies this batch request.
- `response_body_url` (string, optional) — The URL of the gzipped archive of the results of all the operations.
- `status` (enum, optional) — The status of the batch call. [Learn more](https://mailchimp.com/developer/marketing/guides/run-async-requests-batch-endpoint/#check-the-status-of-a-batch-operation) about the batch operation status.
  - Allowed values: `pending`, `preprocessing`, `started`, `finalizing`, `finished`
- `submitted_at` (datetime, optional) — The date and time when the server received the batch request in ISO 8601 format.
- `total_operations` (integer, optional) — The total number of operations to complete as part of this batch request. For GET requests requiring pagination, each page counts as a separate operation.

## Types

### 30BatchesPostRequestBodyContentApplicationJsonSchemaOperationsItems

- `method` (enum, required) — The HTTP method to use for the operation.
  - Allowed values: `GET`, `get`, `POST`, `post`, `PUT`, `put`, `PATCH`, `patch`, `DELETE`, `delete`
- `path` (string, required) — The relative path to use for the operation.
- `body` (string, optional) — A string containing the JSON body to use with the request.
- `headers` (30BatchesPostRequestBodyContentApplicationJsonSchemaOperationsItemsHeaders, optional) — Any HTTP headers to include with the request.
- `operation_id` (string, optional) — An optional client-supplied id returned with the operation results.
- `params` (30BatchesPostRequestBodyContentApplicationJsonSchemaOperationsItemsParams, optional) — Any request query parameters. Example parameters: \{"count":10, "offset":0}

### BatchLinksItems

This object represents a link from the resource where it is found to another resource or action that may be performed.

- `href` (string, optional) — This property contains a fully-qualified URL that can be called to retrieve the linked resource or perform the linked action.
- `method` (enum, optional) — The HTTP method that should be used when accessing the URL defined in 'href'.
  - Allowed values: `GET`, `POST`, `PUT`, `PATCH`, `DELETE`, `OPTIONS`, `HEAD`
- `rel` (string, optional) — As with an HTML 'rel' attribute, this describes the type of link.
- `schema` (string, optional) — For HTTP methods that can receive bodies (POST and PUT), this is a URL representing the schema that the body should conform to.
- `targetSchema` (string, optional) — For GETs, this is a URL representing the schema that the response should conform to.

### BatchCompletedAt

The date and time when all operations in the batch request completed in ISO 8601 format.

### 30BatchesPostRequestBodyContentApplicationJsonSchemaOperationsItemsHeaders

Any HTTP headers to include with the request.

### 30BatchesPostRequestBodyContentApplicationJsonSchemaOperationsItemsParams

Any request query parameters. Example parameters: \{"count":10, "offset":0}

## Examples

**Request**

```json
{
  "operations": [
    {
      "method": "POST",
      "path": "/lists"
    }
  ]
}
```

**Response**

```json
{
  "_links": [
    {
      "href": "string",
      "method": "GET",
      "rel": "string",
      "schema": "string",
      "targetSchema": "string"
    }
  ],
  "completed_at": "",
  "errored_operations": 1,
  "finished_operations": 1,
  "id": "string",
  "response_body_url": "string",
  "status": "pending",
  "submitted_at": "2024-01-15T09:30:00Z",
  "total_operations": 1
}
```

**SDK Code**

```python
import requests

url = "https://api.mailchimp.com/3.0/batches"

payload = { "operations": [
        {
            "method": "POST",
            "path": "/lists"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.mailchimp.com/3.0/batches';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"operations":[{"method":"POST","path":"/lists"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.mailchimp.com/3.0/batches"

	payload := strings.NewReader("{\n  \"operations\": [\n    {\n      \"method\": \"POST\",\n      \"path\": \"/lists\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.mailchimp.com/3.0/batches")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"operations\": [\n    {\n      \"method\": \"POST\",\n      \"path\": \"/lists\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.mailchimp.com/3.0/batches")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"operations\": [\n    {\n      \"method\": \"POST\",\n      \"path\": \"/lists\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.mailchimp.com/3.0/batches', [
  'body' => '{
  "operations": [
    {
      "method": "POST",
      "path": "/lists"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.mailchimp.com/3.0/batches");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"operations\": [\n    {\n      \"method\": \"POST\",\n      \"path\": \"/lists\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["operations": [
    [
      "method": "POST",
      "path": "/lists"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.mailchimp.com/3.0/batches")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```